var sXmlaServer = ""
var sServer = "";
var sCatalog = "";
var sCube = "";
var sMeasureGroup = "";
var sMember = "";
var sThemeId = "";
var oXmlaArray = Array(); //used by oXmla object
var oOpener = null;
var iYear = new Date().getFullYear();
var iMonth = new Date().getMonth();
function IsExpired(){
	var oDate = new Date(); return (oDate.getFullYear()*100 + oDate.getMonth() > 200407)
}

function init(){
	MakeXResizable("idXHandle","idMetadata");

	if (window.dialogArguments){
		oOpener = dialogArguments;
		if (IsSafari2()) document.onkeydown = function(){return false};
		Focus();
	}else if (window.parent){
		oOpener = window.parent;
		setTimeout('Focus()',500);
	}
	
	if(oOpener){
		sXmlaServer = oOpener.sXmlaServer;
		sServer  = oOpener.sServer;
		sCatalog = oOpener.sCatalog;
		sCube    = oOpener.sCube;
		sMeasureGroup = oOpener.sMeasureGroup; 
		sConnectSec = oOpener.sConnectSec;
	
		ResetDimensions();
		ResetCalcMeasures();		

        var oParent = oOpener;
        oWinLevels = oParent.oWinLevels;
        oCalculatedFields = oParent.oWinLevels.oCalculatedFields; //RP based
        oHiddenDims = oParent.oWinLevels.oHiddenDims;
        oProperties = oParent.oWinLevels.oProperties;
        oDims = oParent.oWinLevels.oDims;
        oKpiFolders = oParent.oWinLevels.oKpiFolders;
        oMeasureGroupDims = oParent.oWinLevels.oMeasureGroupDims;
        oCalcultedMeasures = oParent.oWinLevels.oCalcultedMeasures;
        oMeasures = oParent.oWinLevels.oMeasures;
        oMeasureGroups = oParent.oWinLevels.oMeasureGroups;
        oNamedSets = oParent.oWinLevels.oNamedSets; //Internal to AS
        oDimensions = oParent.oWinLevels.oDimensions;
        oLevels = oParent.oWinLevels.oLevels;
        _("idMetadata").innerHTML  = ShowFieldList();

        SetCalcId();
        
        var oSelect = _("selCalcMeasures");
        if (oSelect.length>1 && oSelect.value=="0"){
			SetSelect(oSelect, oSelect.options[1].value);
			SelectOption();
        }
        
        _("selLocaleId").style.display = IsAS2005()?"":"none";
        
        window.setTimeout("OnResize()",50);        
        if (IsIE()==false) window.setTimeout("iHeightOffset = 280; OnResize()",55);
	}
}

function Focus(){
	_("txtName").focus()
}

function ResetDimensions(){
	if (!oOpener || !oOpener.oWinLevels || !oOpener.oWinLevels.oDimensions){return};
	
	var oHiddenDims = oOpener.oHiddenDims;
	_("selDimensions").length = 1;
	
	var oLevels = oOpener.oWinLevels.oDimensions;
	for(i=0;i<oLevels.length;i++){
		var sDimId = oLevels[i];
		var sDimName = oOpener.GetDimName(sDimId);
		if (!oHiddenDims[sDimId]){
			var oOption = new Option(sDimName,sDimId);
			_("selDimensions")[_("selDimensions").length] = oOption;
		}
	}
}

function SetCalcId(){
    if (sCalcId=="") return;
    var iCalcId = parseInt(sCalcId);
    
    if (!oCalculatedFields[iCalcId]) return;
    var sName = oCalculatedFields[iCalcId].name;
    var sId = oCalculatedFields[iCalcId].id
    if (!oOpener.oCalculatedFields[sName]){
        oOpener.SetSavedCalculatedField(sId);
        ResetCalcMeasures();
    }
    
    SetSelect(_("selCalcMeasures"), "["+sName+"]");
    SelectOption();
}

//================================

var oFormulas = [];
var oAllFormulas = [];

function ResetFormulas(){
    _("idFunctions").innerHTML = "<div aign=center>" + sLoadingLabel + "...</div>";

	var sRequestType = "MDSCHEMA_FUNCTIONS";
	var sRestrictions = "<INTERFACE_NAME></INTERFACE_NAME>";
	var oXmla = new Xmla;
	oXmlaArray[oXmlaArray.length] = oXmla;
	oXmla.ReturnCallback = CallBackShowResetFormulas;
	oXmla.Discover(sRequestType,sRestrictions,GetProps());
}

function GetProps(){
	return "<DataSourceInfo>" + sServer + "</DataSourceInfo><Catalog>" + sCatalog + "</Catalog><Format>Tabular</Format><Content>SchemaData</Content>" + GetXmlaProps();
}

function CallBackShowResetFormulas(oDoc){
	var oNodes = SelectNodes(oDoc, "//root/row");
	
	for(var i=0; i< oNodes.length; i++){
		var sFunction = GetXmlNodeText(oNodes[i], "FUNCTION_NAME");
		var sObject = GetXmlNodeText(oNodes[i], "OBJECT");
		var sParam = GetXmlNodeText(oNodes[i], "PARAMETER_LIST");
		var sInterface = GetXmlNodeText(oNodes[i], "INTERFACE_NAME");
		var sDesc = GetXmlNodeText(oNodes[i], "DESCRIPTION");

		var sSample = "";
		if (sParam == "(none)"){
			sSample = sFunction;
		}else{
			sSample = sFunction + "(" + sParam + ")";
		}
		
		var sCaption = "";
		if (sObject != ""){
			sCaption = sFunction + " - " + sObject;
			sSample = "<" + sObject + ">." + sSample;
		}else{
			sCaption =  sFunction;
		}
		
		if (!oFormulas[sInterface]){
		    oFormulas[sInterface] = [];
		}
		
		var oArray = oFormulas[sInterface];
		oArray[oArray.length] = {caption: sCaption, sample: sSample, desc: sDesc};
		oAllFormulas[sCaption] = {sample: sSample, desc: sDesc};
	}
	
	oFormulas = SortFolders(oFormulas);
	oAllFormulas = SortFolders(oAllFormulas);
	
	ShowFormulas();
}

function ShowFormulas(){
    var sRet = "";

	iMemberId ++;
	sRet += GetFolderHtml("(All)");
    for (var sName in oAllFormulas){
        iMemberId ++;
        var oFunc = oAllFormulas[sName];
        var sId = oFunc.sample;
        sAnc = GetDragItem(sId,sName,"");
	    sRet += "<div style='white-space: nowrap;' title='"+oFunc.desc+"'><IMG SRC='../images/MdxFunction.gif' WIDTH=15 HEIGHT=17 border=0>" + sAnc + "</div>";
    }
    sRet += "</div></div>";

    for (var sInterface in oFormulas){
		iMemberId ++;
		sRet += GetFolderHtml(sInterface);

        var oArray = oFormulas[sInterface];
        for (var i=0; i < oArray.length; i++){
            iMemberId ++;
            var oFunc = oArray[i];
            var sName = oFunc.caption;
            var sId = oFunc.sample;
            sAnc = GetDragItem(sId,sName,"");
		    sRet += "<div style='white-space: nowrap;' title='"+oFunc.desc+"'><IMG SRC='../images/MdxFunction.gif' WIDTH=15 HEIGHT=17 border=0>" + sAnc + "</div>";
        }
        sRet += "</div></div>";
    }
    
    _("idFunctions").innerHTML  = sRet;
}

function GetFolderHtml(sName){
    return "<div style='white-space: nowrap;'><IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "'" 
	    + " ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")' border=0>&nbsp;"
		+ "<IMG SRC='../images/folderClosed.gif' ID='fdr" + iMemberId 
		+ "' WIDTH=17 HEIGHT=17 border=0 ONDBLCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>&nbsp;"
		+ "<span style='font-size: 12px' ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>" + sName + "</span>"
		+ "<div style='white-space: nowrap; display:none; margin-left:17px;' ID='div" + iMemberId + "'>";
}

//==========================================================================
//2. Show Field List
var iMemberId = 0;
var iMeasuresId = null;

var oHiddenDims = []
var oProperties = [];
var oDims = [];
var oTempKpis = null;
var oKpiFolders = [];
var oMeasureGroupDims = [];
var oCalculatedFields = []; //RP based
var oCalcultedMeasures = [];
var oCalcultedMeasuresExp = [];
var oMeasuresDesc = [];
var oMeasures = [];
var oMeasureGroups = [];
var oNamedSets = []; //Internal to AS
var oDimensions = [];
var oLevels = [];
var bShowOnlyCalcMeasures = false;
var sTimeDim = "";
var bShowDim2005 = true;

function HandleDragOver(e){
	if (IsIE() || IsFF()) return true;
	return false;
}

function HandleDrop(e){
	if(!e) var e = window.event;
	sMember = GetMemberFormula(sMember);

	if (IsIE() && GetIeVersion()<10){
		e.dataTransfer.setData("text", sMember);
	}else{
		SetTextarea(_("txtFormula"), sMember);
	}

	if (IsFF() || GetIeVersion()>9) CancelBubble(e);
}

function GetMemberFormula(s){
    if (s.indexOf("[Property].[") != -1){
         var iIndex = parseInt(GetNameFromMember(s));
         return oTempProperties[iIndex];
    }else if (s.indexOf("[[Member_Key]].[") != -1){
         var iIndex = parseInt(GetNameFromMember(s));
         return oExpandedMembers[iIndex].id;
    }
    return s;
}

function SetTextarea(input, s){
	if (document.selection) { 
		input.focus(); 
		var sel = document.selection.createRange(); 
		sel.text = s; 
	}else if (typeof input.selectionStart != 'undefined') {
		var iPos1 = input.selectionStart;
		var iPos2 = input.selectionEnd;
		input.value = input.value.substr(0, iPos1) + s + input.value.substr(iPos2);
	}else{
		input.value += s;
	}
}

function ToggleDisplay(id){
	var oButton, oItems;
	oButton = _("btn" + id);
	oItems = _("div" + id);
	
	if (_("div" + id)==null) return;
	
	if ((oItems.style.display == "") || (oItems.style.display == "none")) {
		oItems.style.display = "block";
		oButton.src = "../images/minus.gif";
	} else {
		oItems.style.display = "none";
		oButton.src = "../images/plus.gif";
	}
	
	return false;
}

function ToggleFolderDisplay(iDivId) {
	var oButton = _("btn" + iDivId);
	var oFolder = _("fdr" + iDivId);
	var oItems = _("div" + iDivId);
	
	if (_("div" + iDivId)==null) return;

	if ((oItems.style.display == "") || (oItems.style.display == "none")) {
		oItems.style.display = "block";
		oButton.src = "../images/minus.gif";
		if (oFolder){oFolder.src = "../images/folderOpen.gif"};
	}else{
		oItems.style.display = "none";
		oButton.src = "../images/plus.gif";
		if (oFolder){oFolder.src = "../images/folderClosed.gif"};
	}
	
	return false;
}

function ShowFieldList(){
	var sRet = "";

	//Show Measures Main Folder
	iMemberId++;
	var sName = sCubeLabel;
	var sImg = "<IMG class=hand SRC='../images/minus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
		    + "ONCLICK='javascript:ToggleDisplay(" + iMemberId + ");' BORDER='0'>";
	sImg += "<img border=0 src='../images/measures.gif' width=16 height=15 ondblclick='ToggleDisplay(" + iMemberId + ");'>";
	var sAnc = GetDragItem("[Measures].Members",sName,"");
	var sDiv = "<div style=\"display:block\" ID='div" + iMemberId + "'>";
	sRet = "<div style='white-space: nowrap;'>" + sImg + sAnc + "</div>" + sDiv;
	iMeasuresId = iMemberId

	//Show Measures
	if (IsAS2005()) {
		bShowGroups = CountMembers(oMeasureGroups) > 1 && sMeasureGroup == "";
		sRet += ShowMeasureGroupsHtml(bShowGroups);
	}else{
		if (bShowOnlyCalcMeasures==false){
			sRet += GetMeasuresHtml(oMeasures, false, 20);
		}
		sRet += GetMeasuresHtml(oCalcultedMeasures, true, 20);		 
	}
		
	sRet += GetCalcultedMeasuresList(20,"");
	sRet += "</div>";

	//Show KPI 2005
	if (IsAS2005()){
		var sKpiHtml = ShowKpiHtml(oKpiFolders,1);
		if (sKpiHtml!=""){
			iMemberId++;
			iKpisId = iMemberId;
			
			var sName = "KPI";
			var sImg = "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
				+ "ONCLICK='javascript:ToggleDisplay(" + iMemberId + ");' BORDER='0'>";
			sImg += "&nbsp;<img border=0 src='../images/2005/kpi_icon.gif' width=16 height=16 ondblclick='ToggleDisplay(" + iMemberId + ");'>";
			sAnc = GetDragItem("[Measures].Members",sName,"");

			sRet += "<div style='white-space: nowrap;'>" + sImg + sAnc + "</div>";
			sRet += "<div style='display:none;' ID='div" + iMemberId + "'>";
			sRet += sKpiHtml;
			sRet += "</div>";
		}
	}
	
	//Show Hierarchies
	if (IsAS2005()){		
		sRet += ShowDimensions2005();
	}else{
		sRet += ShowDimensions2000();
	}

	return sRet;
}

function SortFolders(oArray){
	var oRet = [];
	var oNew = [];
	
	for(var s in oArray){
		oNew[oNew.length] = s;
	}
	
	oNew.sort();
	
	for (i=0; i< oNew.length;i++){
		var sKey = oNew[i];
		if (sKey!=""){
			oRet[sKey] = oArray[sKey];
		}
	}
	
	if (oArray[""]){
		oRet[""] = oArray[""];
	}
	
	return oRet;
}

function SortHeirarchies(oArray){
	var oRet = [];
	var oProps = [];
	
	for(var sKey in oArray){
		oProps[oProps.length] = oArray[sKey];
	}
	
	oProps.sort(SortByOrdinal);
	
	for (i=0; i< oProps.length;i++){
		oRet[oProps[i].Id] = oProps[i];
	}

	return oRet;
}

function SortByOrdinal(a, b) {
    var x = parseInt(a.Ordinal);
    var y = parseInt(b.Ordinal);
    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
}

var oShowDim = [];

function SelectDim(){
	sMember = "";
}

function GetDimCaption(sDimId){
	if (oOpener.oWinLevels.oDimProps[sDimId] && oOpener.oWinLevels.oDimProps[sDimId].caption!=""){
	    return oOpener.oWinLevels.oDimProps[sDimId].caption;
	}else{
	    return RemoveBrackets(sDimId);
	}
}

function ShowDimensions2005(){
	oShowDim = [];
	var sRet = "";	
	for(var sDimId in oDims){
		if (sMeasureGroup=="" || oMeasureGroupDims[sDimId]){
			if (bShowDim2005){
				iMemberId ++;
				sRet += "<div style='white-space: nowrap;'><IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "'" + " ONCLICK='ExpandDim2005(" + iMemberId + ")' border=0>&nbsp;" 
						+ "<IMG SRC='../images/2005/Dim.gif' WIDTH=17 HEIGHT=18 border=0 ondragstart='SelectDim()' ONDBLCLICK='ExpandDim2005(" + iMemberId + ")'>&nbsp;"
						+ "<span style='font-size: 12px' ONCLICK='ExpandDim2005(" + iMemberId + ")'>" + GetDimCaption(sDimId) + "</span>"
						+ "<div style='white-space: nowrap; display:none' ID='div" + iMemberId + "'>";
			}
			
			if (bShowDim2005){
				oShowDim[iMemberId] = {dimId:sDimId, expanded:false};
			}else{
				sRet += GetDim2005Html(sDimId);
			}
			
			if (bShowDim2005){
				sRet += "</div></div>";
			}
		}
	}
	return "<div id=idDimensions>" + sRet + "</div>";
}

function ExpandDim2005(iMemId){
	if (oShowDim[iMemId] && oShowDim[iMemId].expanded==false){
		var oDiv = _("div" + iMemId);
		var sDimId = oShowDim[iMemId].dimId;
		oDiv.innerHTML = GetDim2005Html(sDimId);
		oShowDim[iMemId].expanded=true;
	}
	
	ToggleDisplay(iMemId);
}

function GetDim2005Html(sDimId){
	var iIndent = bShowDim2005?18:0;
	var sRet = "";
	var oFolders = SortFolders(oDims[sDimId]);			
	for(var sFolder in oFolders){
		
		if (sFolder!=""){
			iMemberId ++;
			var sChk = "<span nowrap style='margin-left:20px'/>";
			sRet += "<div style='white-space: nowrap; margin-left:" + iIndent + "px'>" + sChk
				+ "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "'" 
				+ " ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")' border=0>&nbsp;" 
				+ "<IMG SRC='../images/folderClosed.gif' ID='fdr" + iMemberId 
				+ "' WIDTH=17 HEIGHT=17 border=0 ONDBLCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>&nbsp;"
				+ "<span style='font-size: 12px' ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>" + sFolder + "</span>"
				+ "<div style='white-space: nowrap; display:none' ID='div" + iMemberId + "'>";
		}
		
		var oHeirarchies = SortHeirarchies(oFolders[sFolder]);
		for(var sId in oHeirarchies){
			if (!oHiddenDims[sId]){
			
				var oHeirarchy = oHeirarchies[sId];
				var sName = oHeirarchy.Name;
				var sType = oHeirarchy.Type;
				var sStructure = oHeirarchy.Structure;
				var oLevels = oHeirarchy.oLevels;
				
				iMemberId++;
				
				if (sType == "1"){
					sTimeDim = sId;
				}
				
				var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";
				sImg = "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
						+ "ONCLICK='javascript:ToggleDisplay(" + iMemberId + ");' BORDER='0'>";
				
				var sImgFile = "";
				if (sStructure == "2"){
					sImgFile = "HierarchyParent.gif"
				}else if (oLevels.length <= 2){
					sImgFile = (sType=="1")?"DimPropT.gif":"DimProp.gif";
				}else if (sType == "1"){
					sImgFile = "HierarchyT.gif";
				}else{
					sImgFile = "Hierarchy.gif";
				}
				
				sImg += "<img border=0 src='../images/2005/" + sImgFile + "' width=18 height=16 onmouseover="+sSelectFunction+" ondblclick='ToggleDisplay(" + iMemberId + ");'>";
				
				var sAnc = GetDragItem(sId,sName,doReplace(oHeirarchy.Desc,'"',''));
				var sDiv = "<div style=\"display:none\" ID='div" + iMemberId + "'>";
				
				if (sFolder==""){
					sRet += "<div style='white-space: nowrap; margin-left:" + iIndent + "px'>" + sImg + sAnc + "</div>" + sDiv;
				}else{
					sRet += "<div style='white-space: nowrap; margin-left:18px'>" + sImg + sAnc + "</div>" + sDiv;
				}					
				
				sRet += ShowHeirarchyMembers(sId, 36);
				sRet += "<div style='white-space: nowrap; margin-left:31px'>" + ShowLevels(oLevels, sType) + "</div>";
				sRet += "</div>";
			}
		}
			
	    //Get NamedSets from AS
        sRet += ShowNamedSet(sDimId, "");
		
		if (sFolder!=""){
			sRet += "</div></div>";		
		}				
	}
	
	return sRet;
}

function ShowDimensions2000(){
	var sRet = "";
	
	for(var sDimId in oDims){
		var oHeirarchies = oDims[sDimId];
		
		for(var sId in oHeirarchies){
			if (!oHiddenDims[sId]){
				var oHeirarchy = oHeirarchies[sId];
				var sName = oHeirarchy.Name;
				var sType = oHeirarchy.Type;

				iMemberId++;
				if (sType == "1"){sTimeDim = sId};

				var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";
				sImg = "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
						+ "ONCLICK='javascript:ToggleDisplay(" + iMemberId + ");' BORDER='0'>";
				
				if (sTimeDim == sId){
					sImg += "<img border=0 src='../images/dimensionT.gif' width=20 height=16 onmouseover="+sSelectFunction+" ondblclick='ToggleDisplay(" + iMemberId + ");'>";
				}else{
					sImg += "<img border=0 src='../images/dimension.gif' width=20 height=16 onmouseover="+sSelectFunction+" ondblclick='ToggleDisplay(" + iMemberId + ");'>";
				}
				
				var sAnc = GetDragItem(sId,sName,"");
				
				sRet += "<div style='white-space: nowrap;'>" + sImg + sAnc + "</div>";
				sRet += "<div style=\"display:none\" ID='div" + iMemberId + "'>"
				sRet += ShowHeirarchyMembers(sId, 5);
				sRet += ShowLevels(oHeirarchy.oLevels, sType);
				sRet += ShowNamedSet(sId, "");
				sRet += "</div>";
			}
		}
	}

	return "<div id=idDimensions>" + sRet + "</div>";
}

var oMemeberIdDim = [];

function ShowHeirarchyMembers(sId,iMargin){
    iMemberId++;
    oMemeberIdDim[iMemberId] = sId;
    var sRet = "<div style='white-space: nowrap; margin-left:"+iMargin+"px'>"
        + "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
		+ "ONCLICK='javascript:ToggleDim(" + iMemberId + ");' BORDER='0' style='margin-bottom:4px'> "
	    + "<img border=0 src='../images/MdxMembers.gif' width=18 height=16 ondblclick='ToggleDim(" + iMemberId + ");'> "
        + "Members <div style=\"display:none\" ID='div" + iMemberId + "'></div></div>";
    return sRet;
}

var oMemeberIdLevel = [];

function ShowLevels(oLevels,sType){
	var sTemp = "";	

	for(var i=0; i< oLevels.length; i++){
		var sId = oLevels[i].id;
		var sName = PadEmpty(oLevels[i].name);
		var iLevelNumber = oLevels[i].level;

		if (sName != "(All)"){
			var sProperties = ShowProperties(sId);
			if (sProperties!=""){
			    sProperties = ShowLevelMembers(sId, 15) + sProperties;
			}

			iMemberId++;
			oMemeberIdLevel[iMemberId] = sId;

			var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";
		    sProperties = "<div style=\"display:none\" ID='div" + iMemberId + "'>" + sProperties + "</div>";
		    var sPropImg = "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
		           + "ONCLICK='ToggleLevel(" + iMemberId + ");' BORDER='0' style='margin-right:3px;'>";
		    var sToggle = " ONDBLCLICK='ToggleLevel(" + iMemberId + ");'";			    
			var sImg = "<img border=0 src='../images/level.gif' width=14 height=16 onmouseover="+sSelectFunction + sToggle + ">";
			sMargin = "<div style='white-space: nowrap;'><img src='../images/spacer.gif' width=5 height=1 border=0>";
			sAnc = GetDragItem(sId,sName,sName) + "</div>";
			sTemp += sMargin + sPropImg + sImg + sAnc;
			sTemp += sProperties;
		}
	}

	return sTemp;
}

function ShowLevelMembers(sId,iMargin){
    iMemberId++;
    oMemeberIdLevel[iMemberId] = sId;
    var sRet = "<div style='white-space: nowrap; margin-left:"+iMargin+"px'>"
        + "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
		+ "ONCLICK='ToggleLevel(" + iMemberId + ");' BORDER='0' style='margin-bottom:4px'> "
	    + "<img border=0 src='../images/MdxMembers.gif' width=18 height=16 ondblclick='ToggleLevel(" + iMemberId + ");'> "
        + "Members</div><div style=\"display:none\" ID='div" + iMemberId + "'></div>";
    return sRet;
}


function ShowNamedSet(sDimension, sDimType){
	if (sDimension == "[Measures]"){return ""};
	sDimension = RemoveBrackets(sDimension);
	var iMargin = IsAS2005()?18:20;
	var sTemp = "";	
	for(var sName in oNamedSets){
		iMemberId++;
		var oDim = oNamedSets[sName].dim.split(",");
		for (var iDim = 0; iDim < oDim.length; iDim++){
			var sDim = RemoveBrackets(oDim[iDim]);
			
			if (sDimension==sDim || SearchCompare(sDim,sDimension,0)){
				var sId = "[" + sName + "]";
				var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";		
				var sMargin = "<div style='white-space: nowrap;'><img src='../images/spacer.gif' width="+iMargin+" height=1 border=0>";
				var sImg = "<img border=0 src='../images/levelNSI.gif' width=14 height=16 onmouseover="+sSelectFunction+">";
				sAnc = GetDragItem(sId,sName,sName) + "</div>";
				sTemp += sMargin + sImg + sAnc;
			}
		}
	}
	return sTemp;
}

var oTempProperties = [];

function GetDimension(s){
	return oOpener.GetDimension(s);
}

function ShowProperties(sLevel){
	if (sLevel =="[Measures]")return "";
	if (!oProperties[sLevel]) return "";
	var sTemp = "";	
	
	for(var sName in oProperties[sLevel]){
		iMemberId++;

		var sImg = "src='../images/property.gif' width=14 height=16";
		var sId = "[Property].[" + iMemberId + "]";
		var sDim = GetDimension(sLevel);
		var sFormula = "IIf("+sDim+".CurrentMember.Level.Name=\""+GetNameFromMember(sLevel)+"\","+sDim+".Properties(\""+sName+"\"), \"\")";
		oTempProperties[iMemberId] = sFormula;

		var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";		
		sMargin = "<img src='../images/spacer.gif' width=30 height=1 border=0>"
				+ "<img border=0 "+sImg+" onmouseover="+sSelectFunction+">";
		sAnc = GetDragItem(sId,sName,sName);
		sTemp += "<div style='white-space:nowrap'>" + sMargin + sAnc + "</div>";
	}
	
	return sTemp;
}

function ShowKpiHtml(oKpis,iLevel){
	var sRet = "";

	for(var sName in oKpis.Children){
		var oKpi = oKpis.Children[sName];

		iMemberId++;
		var sPlus = "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "'" 
					+ " ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")' border=0>&nbsp;";

		if (oKpi.IsKpiItem){
			//not folder

			sRet += "<div style='margin-left:" + (10+10*iLevel) + "px;'>" + sPlus
			+ "<IMG SRC='../images/2005/kpi_icon.gif' ID='kpi" + iMemberId 
			+ "' WIDTH=14 HEIGHT=14 border=0 ONDBLCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>&nbsp;"
			+ "<span style='font-size: 12px' ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>" + sName + "</span>";

			sRet += "<div style='white-space: nowrap; display:none' ID='div" + iMemberId + "'>";
			sRet += GetKpiIcon(oKpi.Value,"value","");
			sRet += GetKpiIcon(oKpi.Goal,"goal","");
			sRet += GetKpiIcon(oKpi.Status,"status",oKpi.StatusGraph);
			sRet += GetKpiIcon(oKpi.Trend,"trend",oKpi.TrendGraph);
			sRet += "</div></div>";

			sRet += ShowKpiHtml(oKpi,iLevel+1);
			
		}else{
			//folder
			sRet += "<div style='margin-left:17px;'>" + sPlus
			+ "<IMG SRC='../images/folderClosed.gif' ID='fdr" + iMemberId 
			+ "' WIDTH=17 HEIGHT=17 border=0 ONDBLCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>&nbsp;"
			+ "<span style='font-size: 12px' ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>" + sName + "</span>"
			+ "<div style='white-space: nowrap; display:none' ID='div" + iMemberId + "'>";

			sRet += ShowKpiHtml(oKpi,iLevel);

			sRet += "</div></div>";
		}
	}
	
	return sRet;
}

function GetKpiIcon(sId,sImgSrc,sKpiGraph){

	iMemberId++;
	var sName = GetNameFromMemberId(sId);

	var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";
	var sImg = "<img border=0 src='../images/2005/kpi_" + sImgSrc + ".gif' width=16 height=16 onmouseover="+sSelectFunction+">";
	var sAnc = GetDragItem(sId,sName,sId);
	return "<div style='white-space: nowrap; margin-left:17px'>" + sImg + sAnc + "</div>" ;
}

function GetMeasureCaption(sMeasure){
	if (oOpener.oWinLevels.oMeasuresProps[sMeasure] && oOpener.oWinLevels.oMeasuresProps[sMeasure].caption!=""){
		return oOpener.oWinLevels.oMeasuresProps[sMeasure].caption;
	}else{
		return GetNameFromMember(sMeasure);
	}
}

function GetMeasuresHtml(oList, bCalculated, iMargin){
	var sMargin = "<img src='../images/spacer.gif' width=" + iMargin + " height=1 border=0>";
	var bAS2005 = IsAS2005();
	var sTemp = "";
	
	for(var i=0; i< oList.length; i++){
		iMemberId++;
		var sId = oList[i];
		var sName = GetMeasureCaption(sId);
		var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";
		var sImgSrc = "";
		
		if (bAS2005){
			if (IsMeasureCalculted(sId)){
				sImgSrc = "2005/measureCalc.gif";
			}else{
				if (bShowOnlyCalcMeasures == false){
					sImgSrc = "2005/measure.gif";
				}				
			}
		}else{
			if (i==0 && !bCalculated){
				sImgSrc = "measureD.gif";
			}else{
				sImgSrc = (bCalculated)?"measureCalcI.gif":"measure.gif";
			}
		}
		
		if (sImgSrc!=""){
			sImg = "<img border=0 src='../images/" + sImgSrc + "' width=14 height=14 onmouseover="+sSelectFunction+">";
			sAnc = GetDragItem(sId,sName,GetMeasureTitle(sId,sName));
			sTemp += "<div style='white-space: nowrap;'>" + sMargin + sImg + sAnc + "</div>";
		}
	}
	
	return sTemp;
}

function CountMembers(oArray){
	var i = 0;
	for (var o in oArray){
		if (o!=""){
			i++;
		}
	}
	return i;
}

function ShowMeasureGroupsHtml(bShowGroups) {
	var sRet = "";

	for (var sGroupName in oMeasureGroups) {
		if (sMeasureGroup == "" || sMeasureGroup == sGroupName) {
			var oMeasureGroup = oMeasureGroups[sGroupName].folders;
			var sGroupCaption = oMeasureGroups[sGroupName].caption;
			if (sGroupCaption == "" || sGroupCaption == " ") sGroupCaption = sGroupName;

			if (bShowGroups){
				iMemberId ++;
				sRet += "<div style='white-space: nowrap; margin-left:17px'>"
					+ "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "'" 
					+ " ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")' border=0>&nbsp;" 
					+ "<IMG SRC='../images/measureGroup.gif' WIDTH=17 HEIGHT=17 border=0 ONDBLCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>&nbsp;"
					+ "<span style='font-size: 12px' ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>" + sGroupCaption + "</span>"
					+ "<div style='white-space: nowrap; display:none' ID='div" + iMemberId + "'>";
			}

			for (var sFolder in oMeasureGroup) {
				var oFolder = oMeasureGroup[sFolder];
				sRet += GetMeasureFolder(oFolder, sFolder, bShowGroups, 1);
			}
			
			if (bShowGroups){
				sRet += "</div></div>";
			}
		}
	}
	return sRet;
}

function GetMeasureFolder(oFolder, sFolder, bShowGroups, iLevel) {
	var sRet = "";

	if (sFolder != "") {
		iMemberId++;
		sRet += "<div style='white-space: nowrap; margin-left:" + (bShowGroups ? 19 : 10) + "px'><div class='boxer' id='Boxer" + iMemberId + "'>"
			+ "<IMG class=hand SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "'"
			+ " ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")' border=0>&nbsp;"
			+ "<IMG SRC='../images/folderClosed.gif' style='vertical-align: top;' ID='fdr" + iMemberId
			+ "' WIDTH=17 HEIGHT=17 border=0 ONDBLCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>&nbsp;"
			+ "<span ONCLICK='javascript:ToggleFolderDisplay(" + iMemberId + ")'>" + sFolder + "</span></div>"
			+ "<div class='FolderCont' style='white-space: nowrap; display:none' ID='div" + iMemberId + "'>";
	}

	sRet += GetMeasuresHtml(oFolder.measures, false, 20);

	if (sFolder != "") {

		for (var sSubFolder in oFolder) {
			if (sSubFolder != "measures") {
				var oSubFolder = oFolder[sSubFolder];
				sRet += GetMeasureFolder(oSubFolder, sSubFolder, bShowGroups, iLevel + 1);
			}
		}

		sRet += "</div></div>";
	}

	return sRet;
}


function GetCalcultedMeasuresList(iIndent, sDimType){
	var sTemp = "";
	for (var sName in oOpener.oCalculatedFields){
		if (oOpener.oCalculatedFields[sName]){
			var sDim = oOpener.oCalculatedFields[sName].Dim;
			if (sDim=="" || sDim=="[Measures]"){

				var sId = "[Measures].[" + sName + "]";	
				iMemberId++;

				var sSelectFunction = "\"SelectMember('" + sId + "','h" + iMemberId + "')\"";		
				var sMargin = "<div style='white-space: nowrap;'><img src='../images/spacer.gif' width=" + iIndent + " height=1 border=0>";
				var sImg = "<img border=0 src='../images/measureCalc.gif' width=14 height=14 onmouseover="+sSelectFunction+">";		
				var sAnc = GetDragItem(sId,sName,"") + "</div>";
				sTemp += sMargin + sImg + sAnc;
			}
		}
	}

	return sTemp;
}

function GetFieldSize(sName){
	return sName.length*16;
}

function GetMeasureTitle(sId,sName){
	if (oMeasuresDesc[sId]){
		return doReplace(oMeasuresDesc[sId],'"','');
	}else if (oCalcultedMeasuresExp[sId]){
		return doReplace(oCalcultedMeasuresExp[sId],'"','');
	}else{
		return sName;
	}
}

function PadEmpty(s){
	if(s==null||s=="")
		return "(Blank)";
	return s;
}

function RemoveBrackets(sName){
	sName = doReplace(sName,"]","");
	sName = sName.replace("[","").replace("[","").replace("[","");
	return sName;
}

function SearchCompare(Str1, Str2, SearchMode) {
  switch(SearchMode) {
	//starting
	case 0:
		return Str1.substr(0,Str2.length) == Str2;
	//ending
	case 1:
	    return Str1.substr(Str1.length-Str2.length, Str2.length) == Str2;
	//containing
	case 2:
	    return Str1.indexOf(Str2)>-1;
 }      
}

function IsMeasureCalculted(sId){
	for(var i=0; i< oCalcultedMeasures.length; i++){
		if (oCalcultedMeasures[i] == sId){
			return true;
		}
	}
	return false;
}

function GetNameFromMemberId(sMember){
	var iPos1 = sMember.lastIndexOf(".[",sMember.length-1);
	var iPos2 = sMember.lastIndexOf("]",sMember.length);
	return sMember.substring(iPos1 + 2, iPos2);
}

//=======================================================


var iHeightOffset = 0;

function OnResize(){
    
    var iWinHeight = IsIE()?document.body.clientHeight:window.innerHeight;    
    
    if (iHeightOffset==0){
        var oCell = _("idLeftCell");
        iHeightOffset = iWinHeight - oCell.offsetHeight;
        if (iHeightOffset<232)iHeightOffset=232;
        if (iHeightOffset>250)iHeightOffset=250;
    }
    
    var iHeight = iWinHeight - iHeightOffset;
    if (UseSvg()) {
    	if (bJsDialog) {
    		iHeight -= 30;
    	} else {
    		iHeight -= 120;
    	}
    } else {
    	iHeight -= 50;
    }

    if (iHeight<10)  return;

    _("idMetadata").style.height = iHeight + "px";
    _("idFunctions").style.height = iHeight + "px";
    
	if (GetIeVersion()>=10){
		_("tblMain").style.width  = document.body.clientWidth + "px";
		_("tblMain").style.height = document.body.clientHeight + "px";
		_("txtFormula").style.height = iHeight + "px";
	}    
}

function TabClick(oTab){
	var id = oTab.id;

	$(".TabContent").hide();
	$("#id" + id).show()

	$(".TabItem").removeClass("active");
	$(oTab).addClass("active");

	if (id == "Functions") {
		if (_("idFunctions").innerHTML == "") {
			ResetFormulas();
		}
		MakeXResizable("idXHandle","idFunctions");
	}else{
		MakeXResizable("idXHandle","idMetadata");
	}	

	document.body.focus();
}

function IsAS2005(){
	return (sXmlaServer.toLowerCase().indexOf("msxisapi.dll") == -1 && sXmlaServer.indexOf("mondrian")==-1)
}

function GetDimName(s){
	var i = s.indexOf("].",1);
	if (i==-1){
		return s;
	}else{
		return s.substring(i+3,s.length-1);
	}
}

var sOldName = "";
var sOldFormula = "";
var sOldFormat = "";
var sOldLocaleId = "";
var sOldDimId = "";
var sOldSaveOptions = "";
var sOldParentId = "";
var sOldSolveOrder = "";	

function SaveOldState(sSelVal){
	if (oOpener.oCalculatedFields[sSelVal]){
		sOldName =sSelVal;
		sOldFormula = oOpener.oCalculatedFields[sSelVal].Formula;
		sOldFormat  = oOpener.oCalculatedFields[sSelVal].Format;
		sOldLocaleId = oOpener.oCalculatedFields[sSelVal].LocaleId;
		sOldDimId = oOpener.oCalculatedFields[sSelVal].Dim;
		sOldSaveOptions = oOpener.oCalculatedFields[sSelVal].SaveOptions;
		sOldParentId = oOpener.oCalculatedFields[sSelVal].ParentId;
		sOldSolveOrder = oOpener.oCalculatedFields[sSelVal].SolveOrder;	
	}
}

function SelectOption(){
	var oSelect = _("selCalcMeasures");
	ShowHideUpdateButtons();
	_("selDimensions").selectedIndex = 0;
	DimensionsChanged();
	
	if(oSelect.value=="0"){
		_("txtName").value = "";
		_("txtFormula").value = "";
		return;
	}
	
	var i = oSelect.selectedIndex;
	if (i==-1){return};

	var sSelVal = RemoveBrackets(oSelect.value);
	if (oOpener.oCalculatedFields[sSelVal]){
		SaveOldState(sSelVal);			
		SetOption(sOldFormat, sOldLocaleId, sOldSaveOptions, sOldDimId, sOldParentId, sOldSolveOrder, sOldName, sOldFormula);
	}
}

function SetOption(sFormat, sLocaleId, sSaveOptions, sDimId, sParentId, sSolveOrder, sName, sMdx){
	SetSelect(_("selFormat"),sFormat);
	SetSelect(_("selLocaleId"),sLocaleId);
	SetSelect(_("selSaveOptions"), sSaveOptions);
	SetSelect(_("selDimensions"), sDimId);
	DimensionsChanged();

	_("hdnParentId").value = sParentId;
	var oMember = GetMember(_("hdnParentId").value);
	if (oMember){
		_("txtParentName").value = oMember.name;	    
	}

	_("txtSolveOrder").value = sSolveOrder;
	_("txtName").value = sName;
	_("txtFormula").value = sMdx;
}

function GetMember(sMember){
	var sMdx = "select {"+sMember+"} on columns from [" + sCube + "]";
	var oXmla = new Xmla;
	var oDoc = oXmla.Execute(sMdx,null,GetXmlaProps());
	var oNodes = SelectNodes(oDoc, "//root/Axes/Axis[@name='Axis0']/Tuples/Tuple");
	if (oNodes.length==0){return null};
	return {id: GetXmlNodeText(oNodes[0], "Member/UName"), name: GetXmlNodeText(oNodes[0],"Member/Caption")};
}

function ShowHideUpdateButtons(){
    var bShow = _("selCalcMeasures").value!="0";
    _("btnUpdate").disabled = !bShow;
    _("btnDelete").disabled = !bShow;
}

function AddCalculatedField(){
	if(!oOpener){return};
	if (!ValidateCalculatedField()){return};
	if (!ValidateName()){return};
	
	if (sThemeId!="") oOpener.SelectTheme(sThemeId);
	oOpener.SetCalculatedField(_("txtName").value, _("txtFormula").value, _("selFormat").value, _("selLocaleId").value, _("selDimensions").value, _("txtSolveOrder").value, _("selSaveOptions").value, _("hdnParentId").value);
	var sError = ValidateMdx();

	if (sError==""){
		ResetCalcMeasures();
		sOldName = _("txtName").value;
		sOldFormula = _("txtFormula").value;
		sOldFormat = _("selFormat").value;
		_("selCalcMeasures").selectedIndex = _("selCalcMeasures").options.length-1;
		
		if (selSaveOptions.value != "1" && window.confirm(oLabels[304]+"?")){
			var sXml = GetSourceXml();
			SaveField("[Measures]",_("txtName").value,_("txtFormula").value,sXml,_("selFormat").value, _("selLocaleId").value, _("selDimensions").value, _("selSaveOptions").value, _("txtSolveOrder").value);
		}

		UpdateOpener();
		ResetCalcMeasures();
		SetSelect(_("selCalcMeasures"), "[" + _("txtName").value + "]");
		SelectOption();
		ShowHideUpdateButtons();

	} else {

		//Error2(sError);
		oOpener.oCalculatedFields[_("txtName").value] = null;
		DeleteSelect(oOpener.oMeasures,"[Measures].[" + _("txtName").value + "]");
		oOpener.RebuildDropBoxes();
		oOpener.BuildMdx();
	}	

}

function DimensionsChanged(){
	_("spParent").style.display = (_("selDimensions").selectedIndex>0)?"":"none";
	_("txtParentName").value = "";
	_("hdnParentId").value = "";
}

function GetSourceXml(){
	return EncloseTag("SolveOrder", _("txtSolveOrder").value) + EncloseTagT("ParentId", _("hdnParentId").value);
}

var sDimension = "";

function GetOlapMember(){
    sDimension = _("selDimensions").value;
    oTextbox = _("hdnParentId");
    oNameTextbox = _("txtParentName");
    ShowParentDialog("MemberSelector.aspx?single=1", 400, 300);
}

function UpdateCalculatedField(bSave){
	if (bSave && !ValidateName()){return};
	if(!oOpener){return};

	var oSelect = _("selCalcMeasures");
	if(bSave && oSelect.value=="0" || oSelect.selectedIndex==-1){
		Warning(oLabels[656]); //Please select a field
		return;
	}

	SaveOldState(_("txtName").value)
	
	//delete memeber with the same case insensitive name like: zz=ZZ
	var sCalcName = _("txtName").value;
	for(var sName in oOpener.oCalculatedFields){
		if (sName.toLowerCase() == sCalcName.toLowerCase()){
			oOpener.oCalculatedFields[sName] = null;
		}
	}
	
	if (sThemeId!="") oOpener.SelectTheme(sThemeId);
	oOpener.SetCalculatedField(_("txtName").value,_("txtFormula").value, _("selFormat").value, _("selLocaleId").value,_("selDimensions").value, _("txtSolveOrder").value, _("selSaveOptions").value, _("hdnParentId").value);

	if (_("selDimensions").value!="[Measures]" && oOpener.oMeasures.length==0){
		Warning("Please select a measure to test this calculated member.");
		Close();
		return;
	}

	var sError = ValidateMdx();
	if (sError==""){
		var i = _("selCalcMeasures").selectedIndex;
		var sSelVal = RemoveBrackets(_("selCalcMeasures").value);
		
		if (_("txtName").value != sSelVal){
			//delete member
			if (oOpener.oCalculatedFields[sSelVal]){
				oOpener.oCalculatedFields[sSelVal] = null;
			}			
			
			if (_("selDimensions").value=="[Measures]"){
				DeleteSelect(oOpener.oMeasures,"[Measures]." + oSelect.value);
			}else{
				oOpener.SetFilteredMember(_("selDimensions").value,"");
			}
		}
	
		ResetCalcMeasures();
		SetSelect(_("selCalcMeasures"), "[" + _("txtName").value + "]");
		
		if (bSave){
			_("selCalcMeasures").selectedIndex = i;
		}else{
			SetSelect(oSelect,"[" + _("txtName").value + "]");
		}		

		if (bSave && _("selSaveOptions").value != "1" && window.confirm(oLabels[304]+"?")){
			var sXml = GetSourceXml();
			SaveField("[Measures]",_("txtName").value,_("txtFormula").value,sXml,_("selFormat").value, _("selLocaleId").value, _("selDimensions").value, _("selSaveOptions").value);
		}
		
		UpdateOpener();
	}else{
		Error2(sError);
		if (bSave){
			oOpener.SetCalculatedField(sOldName,sOldFormula,sOldFormat, sOldLocaleId, sOldDimId, sOldSolveOrder, sOldSaveOptions, sOldParentId);
			oOpener.RebuildDropBoxes();
			oOpener.BuildMdx();
		}
	}
	
	ShowHideUpdateButtons();
}

function EncloseTag(sTag, sValue){
	if (sValue=="") return "";
    return "<" + sTag + ">" + sValue + "</" + sTag + ">"
}

function ValidateMdx(){
	oOpener.BuildMdx();
	var sRange = "<BeginRange>0</BeginRange><EndRange>0</EndRange>" + GetXmlaProps();
	var sMdx = oOpener.document.forms[0].txtMDXQuery.value;
	var oXmla = new Xmla;
	var oDoc = oXmla.Execute(sMdx,null,sRange);
	return GetFault(oDoc);
}

function DeleteCalculatedField(){
	if(!oOpener){return};
	var oSelect = _("selCalcMeasures");
	if(oSelect.value=="0"){return};
	if(oSelect.selectedIndex==-1){return};
	
	var sSelVal = RemoveBrackets(oSelect.value);
	if (oOpener.oCalculatedFields[sSelVal]){
	    oOpener.oCalculatedFields[sSelVal] = null;
	    if (_("selDimensions").value=="[Measures]"){
			DeleteSelect(oOpener.oMeasures,"[Measures]." + oSelect.value);
		}else{
			oOpener.SetFilteredMember(_("selDimensions").value,"");
		}
		ResetCalcMeasures();
		
		if (_("selSaveOptions").value != "1" && window.confirm(oLabels[304]+"?")){
			DeleteField("[Measures]",_("txtName").value,_("selDimensions").value);
		}

		UpdateOpener();
	}
	
	_("txtName").value = "";
	_("txtFormula").value = "";
}

function DeleteSelect(oList,sValue){
	for(var i=0;i<oList.length;i++){
		if (oList[i].value == sValue){
			oList.splice(i, 1); 
			return;
		}
	}
}

function ValidateName(){
	if (_("txtName").value == ""){
		//Name? 143
		Warning(oLabels[143] + "?");
		_("txtName").focus();
		return false;
	}

	if (_("txtName").value.indexOf("'")!=-1){
		Warning("Name cannot contain single quote.");
		_("txtName").focus();
		return false;
	}

	if (_("txtName").value.indexOf("\"")!=-1){
		Warning("Name cannot contain double quote.");
		_("txtName").focus();
		return false;
	}

	return true;
}

function ValidateCalculatedField(){
	if (_("txtFormula").value == ""){
		//Please enter formula
		Warning(oLabels[657]);
		_("txtFormula").focus();
		return false;
	}

	var oMeasures = oOpener.oWinLevels.oMeasures;
	for(i=0;i<oMeasures.length;i++){
		var sMeasureName = GetNameFromMember(oMeasures[i]);
		if (_("txtName").value == sMeasureName){
			//Name is not unique.  Please choose another name.
			Warning(oLabels[649]);
			_("txtName").focus();
			return false;
		}
	}
	
	for (var sField in oOpener.oCalculatedFields){
		if (oOpener.oCalculatedFields[sField]){
			if (_("txtName").value == sField){
				//Name is not unique.  Please choose another name.
				Warning(oLabels[649]);
				_("txtName").focus();
				return false;
			}
		}
	}	
	
	return true;
}

function ResetCalcMeasures(){
	if (!oOpener){return};
	
	var oSelect = _("selCalcMeasures");
	oSelect.length = 0;
	oSelect[oSelect.length] = new Option(sNewCalculatedMeasureLabel, "0");
	
	for (var sField in oOpener.oCalculatedFields){
		if (oOpener.oCalculatedFields[sField]){
			var sId = "[" + sField + "]";
			var oOption = new Option(sField,sId);
			oSelect[oSelect.length] = oOption;
		}
	}
	
	ShowHideUpdateButtons();
}

function ToolBarOver(o){
	o.className='ToolbarButtonOver';
}

function ToolBarOut(o){
	o.className='ToolbarButton';
}

function OpenMdxWizard(){
	ShowParentDialog('MdxWizard.aspx', 450, 645);
}

function OpenKpiWizard(){
	ShowParentDialog('KPIWizard.aspx', 450, 400);
}

function OpenSaved(){
	ShowParentDialog("CalculatedSaved.aspx", 400, 400);
}

function OpenDataBarsWizard(){
	ShowParentDialog('DataBarsWizard.aspx', 450, 400);
}

function OpenBigBoxWizard(){
	ShowParentDialog('BigBoxWizard.aspx', 700, 700);
}

//======================
var oExpandedMembers = [];
var oMemberNodes = [];
var iSelectedNodeId = 0;

function ToggleLevel(id){
    ToggleDisplay(id);

    var oNode = _("div" + id);
	if (oNode.innerHTML != "") return;

    var sLevel = oMemeberIdLevel[id];
    var sDim = GetDimension(sLevel);
    var sMembers = GetDimCalcMembersMdx(sDim);
    var sWhere = GetWhereClause(sDim);
    var sNonEmpty = (sWhere=="")?"":" NON EMPTY ";
	var sMdx = "with " +sMembers+ " set [Test] AS '" + sLevel + ".AllMembers'" +
					" select {[Measures].DefaultMember} on rows, " + sNonEmpty +
					" [Test] on columns " +
					" from [" + sCube + "] " + sWhere;
	
	var oXmla = new Xmla;
	var oDoc = oXmla.Execute(sMdx,null,GetXmlaProps());
	var oNodes = SelectNodes(oDoc, "//root/Axes/Axis[@name='Axis0']/Tuples/Tuple");
	var sRet = "";

	for(var i=0; i< oNodes.length; i++){
		var sId = GetXmlNodeText(oNodes[i], "Member/UName");
		var sName = PadEmpty(GetXmlNodeText(oNodes[i], "Member/Caption"));
		sRet += GetMemberString(sId,sName,-1);
	}
    
    try{
        oNode.innerHTML = sRet;
    }catch(ex){
       	Error2("Invalid HTML: " + sRet);
    }
}

function GetDimCalcMembersMdx(sDimension){
    var sMembers = "";
    for (var sField in oOpener.oCalculatedFields){
		if (oOpener.oCalculatedFields[sField] && oOpener.oCalculatedFields[sField].Dim==sDimension){
			var sParentId = oOpener.oCalculatedFields[sField].ParentId;
			var sDim = (sParentId=="")?sDimension:sParentId;
			sMembers += " member " + sDim + ".[" + sField + "] as '" + doReplace(oOpener.oCalculatedFields[sField].Formula,"'","''") + "' ";
		}
    }
    return sMembers;
}

function ToggleDim(id){
    ToggleDisplay(id);

    var oNode = _("div" + id);
	if (oNode.innerHTML != "") return;

    var sDimension = oMemeberIdDim[id];
    var sMembers = GetDimCalcMembersMdx(sDimension);
    var sWhere = GetWhereClause(sDimension);
    var sNonEmpty = (sWhere=="")?"":" NON EMPTY ";
	var sMdx = "with " + sMembers + " set [Test] AS '" + sDimension + ".Levels(0).AllMembers'" +
					" select {[Measures].DefaultMember} on rows, " + sNonEmpty +
					" [Test] on columns " +
					" from [" + sCube + "] " + sWhere;					
	
	var oXmla = new Xmla;
	var oDoc = oXmla.Execute(sMdx,null,GetXmlaProps());
	var oNodes = SelectNodes(oDoc, "//root/Axes/Axis[@name='Axis0']/Tuples/Tuple");
	var sRet = "";

	for(var i=0; i< oNodes.length; i++){
		var sId = GetXmlNodeText(oNodes[i],"Member/UName");
		var sName = PadEmpty(GetXmlNodeText(oNodes[i], "Member/Caption"));
		sRet += GetMemberString(sId,sName,0);
	}
    
    oNode.innerHTML = sRet;
}


function GetChildMembersX(){
	GetChildMembers(iSelectedNodeId);
}

function GetChildMembers(id){
	iSelectedNodeId = id;

    var oNode = _("div" + id);
	if (oNode.innerHTML == ""){
		oNode.innerHTML = "<center>" + sLoadingLabel + "...</center>";
		window.setTimeout("GetChildMembersX()",20);
		return;
	}

    var sNode = oExpandedMembers[id].id;
    var sDim = oExpandedMembers[id].dim;
    var sMembers = GetDimCalcMembersMdx(sDim);
    var sWhere = GetWhereClause(sDim);
    var sNonEmpty = (sWhere=="")?"":" NON EMPTY ";
    var sMeasures = (sWhere=="")?"[Measures].[Blank]":"[Measures].DefaultMember";
	var sMdx = "with " + sMembers + " member [Measures].[Blank] as '(0)'" +
	          " select {" + sMeasures + "} on columns, " + sNonEmpty +
	          " {AddCalculatedMembers(" + sNode + ".Children)} on rows " +
	          " from [" + sCube + "]" + sWhere;
	
	var oXmla = new Xmla;
	var oDoc = oXmla.Execute(sMdx,null,GetXmlaProps());
	var oNodes = SelectNodes(oDoc, "//root/Axes/Axis[@name='Axis1']/Tuples/Tuple");
	var sRet = "";

	for(var i=0; i< oNodes.length; i++){
		sId = GetXmlNodeText(oNodes[i],"Member/UName");
		sName = PadEmpty(GetXmlNodeText(oNodes[i],"Member/Caption"));
		iLevel = GetXmlNodeInt(oNodes[i], "Member/LNum");
		sRet += GetMemberString(sId,sName,iLevel);
	}

	oNode.innerHTML = sRet;
}

function GetMemberString(sId,sName,iLevel){
	iMemberId++;
	var sDim = GetDimension(sId);
	var iLastLevelNumber = GetLastLevelNumber(sDim);
	oExpandedMembers[iMemberId] = {id: sId, name: sName, dim: sDim};

	if (iLevel != iLastLevelNumber && iLevel!=-1){
		var sImg = "<IMG SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemberId + "' "
				 + "ONCLICK='javascript:ToggleDisplayX(" + iMemberId +");' BORDER='0'>";
	}else{
		var sImg = "<IMG src='../images/spacer.gif' WIDTH=12 HEIGHT=10>";
	}

    var sMemberKey = "[[Member_Key]].[" + iMemberId + "]";    
    var sSelectFunction = "\"SelectMember('" + sMemberKey + "','h" + iMemberId + "')\"";		
	return "<div style='white-space: nowrap; padding-left:" + ((iLevel*10)+20) + "'>" + sImg + "&nbsp;<IMG src='../images/MdxMember.gif' WIDTH=11 HEIGHT=10 onmouseover="+sSelectFunction+">" 
        + GetDragItem(sMemberKey,sName,"") + "</div>"
	    + "<div style=\"white-space: nowrap; display:none\" ID='div" + iMemberId + "'></div>";
}

function ToggleDisplayX(id){
    ToggleDisplay(id);
    GetChildMembers(id);
}

function GetLastLevelNumber(sDim){
	if (oLevels.length==0){return -1};
	
	var sLevel = "";
	for(var i=0; i< oLevels.length; i++){
		var sDimension = oLevels[i][1];
		if (sDimension == sDim){
			sLevel = oLevels[i][2];
		}
	}
	return sLevel;	
}

function GetDragItem(sMemberKey,sName,sTitle){
	return "&nbsp;<span onmousedown=\"SelectElement(this)\" "
					+ " onmouseover=\"SelectElement(this)\""
					+ " onmouseout=\"DeselectElement(this)\""
					+ " ondragstart=\"SetMember('" + sMemberKey + "')\""
					+ " ondblclick=\"AppendToText('" + sMemberKey + "')\""
					+ " title=\""+ sTitle + "\" id=h" + iMemberId + " style='cursor: pointer;'>" 
					+ sName + "</span>";
}

function AppendToText(s){
	_("txtFormula").value += GetMemberFormula(s);
}

function SetMember(sMem){	
	sMember = sMem;
}

function SelectMember(sMem,sNodeName){	
	sMember = sMem;
	SelectElement(_(sNodeName));
}

function DeselectElement(o){
	if (IsIE()==false) DeSelectAll();
}

function SelectElement(o){
	if (o==null) return;
	if (IsIE()==false) DeSelectAll();

	if (document.selection){
		var r = document.body.createTextRange();
		r.moveToElementText(o);
		r.select();
	}else if (window.getSelection) {
		var range = document.createRange();
		range.selectNode(o);
		window.getSelection().addRange(range);
	}
}

function DeSelectAll(){
	if (document.selection){
		document.selection.empty(); 
	}else if (window.getSelection){
		window.getSelection().removeAllRanges();
	}
}

function HideJsDialog(){
	parent.HideJsDialog();
}

function Close(){
	window.close();
	if (window != parent && parent.HideJsDialog) parent.HideJsDialog();
}

function GetXmlaProps(){
	if (oOpener.GetXmlaProps) return oOpener.GetXmlaProps();
	return "";
}

function GetWhereClause(sDimension){
	var sRet = "";
	for (var sDim in oHiddenDims){
		if (sDim != sDimension){
			var sId = oHiddenDims[sDim];
			if (sId!=""){
				if (sRet!="") sRet += ", ";
				sRet += sId;
			}
		}
	}
	
	if (sRet!="") return " WHERE ({" + sRet + "})"
	return "";
}

function AddAction(){
	ShowParentDialog("AddAction.aspx?calc=1", 450, 500);
}

function UpdateOpener(){
	oOpener.RebuildDropBoxes();
	oOpener.BuildAndExecute();
	if (IsIE()==false && IsFF()==false) Close();
}
